hpp-core: hpp::core::steeringMethod::ConstantCurvature Class Reference

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::core::steeringMethod::ConstantCurvature Class Reference

Path of constant curvature for a carlike robot. More...

`#include <hpp/core/steering-method/constant-curvature.hh>`

Inheritance diagram for hpp::core::steeringMethod::ConstantCurvature:
[legend]
Collaboration diagram for hpp::core::steeringMethod::ConstantCurvature:
[legend]

## Classes
struct | Wheels_t

## Public Types
typedef Path | parent_t

## Public Member Functions
virtual | ~ConstantCurvature ()
virtual PathPtr_t | copy () const
| Return a shared pointer to a copy of this.
virtual PathPtr_t | copy (const ConstraintSetPtr_t &constraints) const
Configuration_t | initial () const
| Get the initial configuration.
Configuration_t | end () const
| Get the final configuration.
virtual PathPtr_t | reverse () const
Public Member Functions inherited from hpp::core::Path
virtual | ~Path ()
| Destructor.
template<class T >
shared_ptr< T > | as (void)
| Static cast into a derived type.
template<class T >
shared_ptr< const T > | as (void) const
| Static cast into a derived type.
PathPtr_t | extract (const interval_t &subInterval) const
PathPtr_t | extract (const value_type &tmin, const value_type &tmax) const
Configuration_t | eval (const value_type &time, bool &success) const
| Configuration at time.
bool | eval (ConfigurationOut_t result, const value_type &time) const
| Configuration at time.
bool | at (const value_type &time, ConfigurationOut_t result) const
| Get the configuration at a parameter without applying the constraints.
void | derivative (vectorOut_t result, const value_type &time, size_type order) const
void | velocityBound (vectorOut_t result, const value_type &t0, const value_type &t1) const
size_type | outputSize () const
| Get size of configuration space.
size_type | outputDerivativeSize () const
| Get size of velocity.
const interval_t & | timeRange () const
| Get interval of definition.
virtual value_type | length () const
| Get length of definition interval.
const ConstraintSetPtr_t & | constraints () const
| Get constraints the path is subject to.
const interval_t & | paramRange () const
const TimeParameterizationPtr_t & | timeParameterization () const
| Get the time parameterization function.
void | timeParameterization (const TimeParameterizationPtr_t &tp, const interval_t &tr)
| Set the time parameterization function.

## Static Public Member Functions
static ConstantCurvaturePtr_t | create (const DevicePtr_t &robot, ConfigurationIn_t init, ConfigurationIn_t end, value_type curveLength, value_type pathLength, value_type curvature, size_type xyId, size_type rzId, const JointPtr_t rz, const std::vector< JointPtr_t > wheels, const ConstraintSetPtr_t &constraints)
static ConstantCurvaturePtr_t | createCopy (const ConstantCurvaturePtr_t &other)
| Create instance and return shared pointer.
static ConstantCurvaturePtr_t | createCopy (const ConstantCurvaturePtr_t &other, const ConstraintSetPtr_t &constraints)
| Create instance and return shared pointer.

## Protected Member Functions
virtual std::ostream & | print (std::ostream &os) const
| Print path in a stream.
| ConstantCurvature (const DevicePtr_t &robot, ConfigurationIn_t init, ConfigurationIn_t end, value_type curveLength, value_type pathLength, value_type curvature, size_type xyId, size_type rzId, const JointPtr_t rz, const std::vector< JointPtr_t > wheels)
| ConstantCurvature (const DevicePtr_t &robot, ConfigurationIn_t init, ConfigurationIn_t end, value_type curveLength, value_type pathLength, value_type curvature, size_type xyId, size_type rzId, const JointPtr_t rz, const std::vector< JointPtr_t > wheels, ConstraintSetPtr_t constraints)
| ConstantCurvature (const ConstantCurvature &other)
| Copy constructor.
| ConstantCurvature (const ConstantCurvature &other, const ConstraintSetPtr_t &constraints)
| Copy constructor with constraints.
virtual bool | impl_compute (ConfigurationOut_t result, value_type param) const
| Function evaluation without applying constraints.
virtual void | impl_derivative (vectorOut_t result, const value_type &param, size_type order) const
| Virtual implementation of derivative.
virtual void | impl_velocityBound (vectorOut_t bound, const value_type &param0, const value_type &param1) const
| Virtual implementation of velocity bound.
virtual PathPtr_t | impl_extract (const interval_t &paramInterval) const
| Virtual implementation of path extraction.
void | init (const ConstantCurvatureWkPtr_t &weak)
| store weak pointer to itself
| ConstantCurvature ()
| For serialization only.
Protected Member Functions inherited from hpp::core::Path
| Path (const interval_t &interval, size_type outputSize, size_type outputDerivativeSize, const ConstraintSetPtr_t &constraints)
| Path (const interval_t &interval, size_type outputSize, size_type outputDerivativeSize)
| Path (const Path &path)
| Copy constructor.
| Path (const Path &path, const ConstraintSetPtr_t &constraints)
| Copy constructor with constraints.
void | init (const PathWkPtr_t &self)
void | constraints (const ConstraintSetPtr_t &constraint)
virtual void | checkPath () const
| Should be called by child classes after having init.
void | timeRange (const interval_t &timeRange)
value_type | paramLength () const
Configuration_t | configAtParam (const value_type &param, bool &success) const
| Path ()

## Additional Inherited Members
Protected Attributes inherited from hpp::core::Path
interval_t | paramRange_
| Interval of parameters.

## Detailed Description

Path of constant curvature for a carlike robot.

## Member Typedef Documentation

## ◆ parent_t

typedef Path hpp::core::steeringMethod::ConstantCurvature::parent_t

## Constructor & Destructor Documentation

## ◆ ~ConstantCurvature()

virtual hpp::core::steeringMethod::ConstantCurvature::~ConstantCurvature | ( |  | ) |
| inlinevirtual

## ◆ ConstantCurvature() [1/5]

hpp::core::steeringMethod::ConstantCurvature::ConstantCurvature | ( | const DevicePtr_t & | robot,
|  | ConfigurationIn_t | init,
|  | ConfigurationIn_t | end,
|  | value_type | curveLength,
|  | value_type | pathLength,
|  | value_type | curvature,
|  | size_type | xyId,
|  | size_type | rzId,
|  | const JointPtr_t | rz,
|  | const std::vector< JointPtr_t > | wheels
| ) |  |
| protected

Constructor

Parameters

  robot | the carlike robot,
  init,end | Initial and final configurations of the path,
  curveLength | distance traveled by the middle of the rear wheel axis, negative values correspond to backward motions
  pathLength | length of the interval of definition. Should be positive,
  curvature | curvature of the path,
  xyId | id of degrees of freedom corresponding to (x,y) coordinates of robot,
  rzId | id of degrees of freedom corresponding to orientation of robot.
  rz | joint corresponding to orientation of robot,
  wheels | vector of joints corresponding to wheels.

## ◆ ConstantCurvature() [2/5]

hpp::core::steeringMethod::ConstantCurvature::ConstantCurvature | ( | const DevicePtr_t & | robot,
|  | ConfigurationIn_t | init,
|  | ConfigurationIn_t | end,
|  | value_type | curveLength,
|  | value_type | pathLength,
|  | value_type | curvature,
|  | size_type | xyId,
|  | size_type | rzId,
|  | const JointPtr_t | rz,
|  | const std::vector< JointPtr_t > | wheels,
|  | ConstraintSetPtr_t | constraints
| ) |  |
| protected

Constructor

Parameters

  robot | the carlike robot,
  init,end | Initial and final configurations of the path,
  curveLength | distance traveled by the middle of the rear wheel axis, negative values correspond to backward motions
  pathLength | length of the interval of definition. Should be positive,
  curvature | curvature of the path,
  xyId | id of degrees of freedom corresponding to (x,y) coordinates of robot,
  rzId | id of degrees of freedom corresponding to orientation of robot.
  rz | joint corresponding to orientation of robot,
  wheels | vector of joints corresponding to wheels,
  constraints | set of contraints the path is suject to.

## ◆ ConstantCurvature() [3/5]

hpp::core::steeringMethod::ConstantCurvature::ConstantCurvature | ( | const ConstantCurvature & | other | ) |
| protected

Copy constructor.

## ◆ ConstantCurvature() [4/5]

hpp::core::steeringMethod::ConstantCurvature::ConstantCurvature | ( | const ConstantCurvature & | other,
|  | const ConstraintSetPtr_t & | constraints
| ) |  |
| protected

Copy constructor with constraints.

## ◆ ConstantCurvature() [5/5]

hpp::core::steeringMethod::ConstantCurvature::ConstantCurvature | ( |  | ) |
| inlineprotected

For serialization only.

## Member Function Documentation

## ◆ copy() [1/2]

virtual PathPtr_t hpp::core::steeringMethod::ConstantCurvature::copy | ( |  | ) | const
| virtual

Return a shared pointer to a copy of this.

Implements hpp::core::Path.

## ◆ copy() [2/2]

virtual PathPtr_t hpp::core::steeringMethod::ConstantCurvature::copy | ( | const ConstraintSetPtr_t & | constraints | ) | const
| inlinevirtual

Return a shared pointer to a copy of this with constraints

Parameters

  constraints | constraints to apply to the copy

Precondition
  *this should not have constraints.

Implements hpp::core::Path.

## ◆ create()

static ConstantCurvaturePtr_t hpp::core::steeringMethod::ConstantCurvature::create | ( | const DevicePtr_t & | robot,
|  | ConfigurationIn_t | init,
|  | ConfigurationIn_t | end,
|  | value_type | curveLength,
|  | value_type | pathLength,
|  | value_type | curvature,
|  | size_type | xyId,
|  | size_type | rzId,
|  | const JointPtr_t | rz,
|  | const std::vector< JointPtr_t > | wheels,
|  | const ConstraintSetPtr_t & | constraints
| ) |  |
| static

Create instance and return shared pointer.

Parameters

  robot | the carlike robot,
  init,end | Initial and final configurations of the path,
  curveLength | distance traveled by the middle of the rear wheel axis, negative values correspond to backward motions
  pathLength | length of the interval of definition. Should be positive,
  curvature | curvature of the path,
  xyId | id of degrees of freedom corresponding to (x,y) coordinates of robot,
  rzId | id of degrees of freedom corresponding to orientation of robot.
  rz | joint corresponding to orientation of robot,
  wheels | vector of joints corresponding to wheels,
  constraints | set of contraints the path is suject to.

## ◆ createCopy() [1/2]

static ConstantCurvaturePtr_t hpp::core::steeringMethod::ConstantCurvature::createCopy | ( | const ConstantCurvaturePtr_t & | other | ) |
| static

Create instance and return shared pointer.

## ◆ createCopy() [2/2]

static ConstantCurvaturePtr_t hpp::core::steeringMethod::ConstantCurvature::createCopy | ( | const ConstantCurvaturePtr_t & | other,
|  | const ConstraintSetPtr_t & | constraints
| ) |  |
| static

Create instance and return shared pointer.

## ◆ end()

Configuration_t hpp::core::steeringMethod::ConstantCurvature::end | ( |  | ) | const
| inlinevirtual

Get the final configuration.

Implements hpp::core::Path.

## ◆ impl_compute()

virtual bool hpp::core::steeringMethod::ConstantCurvature::impl_compute | ( | ConfigurationOut_t | configuration,
|  | value_type | param
| ) |  | const
| protectedvirtual

Function evaluation without applying constraints.

Returns
  true if everything went good.

Implements hpp::core::Path.

## ◆ impl_derivative()

virtual void hpp::core::steeringMethod::ConstantCurvature::impl_derivative | ( | vectorOut_t | result,
|  | const value_type & | param,
|  | size_type | order
| ) |  | const
| protectedvirtual

Virtual implementation of derivative.

Reimplemented from hpp::core::Path.

## ◆ impl_extract()

virtual PathPtr_t hpp::core::steeringMethod::ConstantCurvature::impl_extract | ( | const interval_t & | paramInterval | ) | const
| protectedvirtual

Virtual implementation of path extraction.

Reimplemented from hpp::core::Path.

## ◆ impl_velocityBound()

virtual void hpp::core::steeringMethod::ConstantCurvature::impl_velocityBound | ( | vectorOut_t | bound,
|  | const value_type & | param0,
|  | const value_type & | param1
| ) |  | const
| protectedvirtual

Virtual implementation of velocity bound.

Reimplemented from hpp::core::Path.

## ◆ init()

void hpp::core::steeringMethod::ConstantCurvature::init | ( | const ConstantCurvatureWkPtr_t & | weak | ) |
| inlineprotected

store weak pointer to itself

## ◆ initial()

Configuration_t hpp::core::steeringMethod::ConstantCurvature::initial | ( |  | ) | const
| inlinevirtual

Get the initial configuration.

Implements hpp::core::Path.

## ◆ print()

virtual std::ostream & hpp::core::steeringMethod::ConstantCurvature::print | ( | std::ostream & | os | ) | const
| protectedvirtual

Print path in a stream.

Reimplemented from hpp::core::Path.

## ◆ reverse()

virtual PathPtr_t hpp::core::steeringMethod::ConstantCurvature::reverse | ( |  | ) | const
| virtual

Reversion of a path

Returns
  a new path that is this one reversed.

Reimplemented from hpp::core::Path.

The documentation for this class was generated from the following file:

- include/hpp/core/steering-method/constant-curvature.hh